Package: spray
Type: Package
Title: Sparse Arrays and Multivariate Polynomials
Version: 1.0-26
Authors@R: person(given=c("Robin", "K. S."), family="Hankin",
           role = c("aut","cre"),
	   email="hankin.robin@gmail.com",
	   comment = c(ORCID = "0000-0001-5982-0415"))
Maintainer: Robin K. S. Hankin <hankin.robin@gmail.com>
Description: Sparse arrays interpreted as multivariate polynomials.
    Uses 'disordR' discipline (Hankin, 2022,
    <doi:10.48550/ARXIV.2210.03856>).  To cite the package in
    publications please use Hankin (2022) <doi:10.48550/ARXIV.2210.10848>.
License: GPL (>= 2)
Depends: methods
Suggests: polynom, testthat, covr
Imports: Rcpp (>= 0.12.3), partitions, magic, disordR (>= 0.9-6),
        stringr
LinkingTo: Rcpp
URL: https://github.com/RobinHankin/spray,
        https://robinhankin.github.io/spray/
BugReports: https://github.com/RobinHankin/spray/issues
Author: Robin K. S. Hankin [aut, cre] (<https://orcid.org/0000-0001-5982-0415>)
Built: R 4.4.1; x86_64-apple-darwin21.6.0; 2024-08-20 16:19:42 UTC; unix

## NB: this seems to work nicely under windows but not on the mac (the
## text is too big) or on linux (the colour comes out wrong).

library("hexSticker")

plotseq <- function(angle){
  v <- seq(from=0,to=1,len=10)
  points(v*sin(angle),-v*cos(angle),pch=16,cex=3.5*sqrt(1-v))
}

png(file="spray_icon.png",width=1000,height=1000,bg="#7733FF")
par(mai=c(0,0,0,0))
plot(NA,xlim=c(-1,1),ylim=c(-1,1),axes=FALSE,xlab="",ylab="",asp=1)
for(angle in seq(from=-0.6,to=0.6,len=7)){plotseq(angle)}
# abline(v=0,lwd=4)  # here for centering
dev.off()

sticker("spray_icon.png", package="spray", p_size=24, s_x=1, s_y=1.8,
s_width=2, asp=0.85, white_around_sticker=TRUE, h_fill="#7733FF",
h_color="#000000", filename="spray.png")

## Four-square identity for sprays

test_that("four-square identity",{
    # first a cute test:
    LHS <- spray(cbind(diag(2,4),diag(0,4)))*spray(cbind(diag(0,4),diag(2,4)))

    RHS <-
  spray(kronecker(t(rep(1,2)),diag(4)))^2+
    spray(cbind(diag(4),magic::adiag(1-diag(2),1-diag(2))),c(1,-1,1,-1))^2 + 
      spray(cbind(diag(4),kronecker(1-diag(2),diag(2))), c(1,-1,-1,1))^2 +
        spray(cbind(diag(4),magic::arev(diag(4),1)), c(1,1,-1,-1))^2

    expect_true(is.zero(LHS-RHS))
    expect_true(is.zero(RHS-LHS))
    expect_true(LHS == RHS)


    # Now a very tough test:
    foo <- function(
                    a1,a2,a3,a4,
                    b1,b2,b3,b4)
    {
        LHS <- (a1^2+a2^2+a3^2+a4^2)*(b1^2+b2^2+b3^2+b4^2)
        RHS <- (
            (a1*b1-a2*b2-a3*b3-a4*b4)^2 +
            (a1*b2+a2*b1+a3*b4-a4*b3)^2 +
            (a1*b3-a2*b4+a3*b1+a4*b2)^2 +
            (a1*b4+a2*b3-a3*b2+a4*b1)^2
        )

    expect_true(is.zero(LHS-RHS))
    expect_true(is.zero(RHS-LHS))
    expect_true(LHS == RHS)
    }

    for(i in 1:4){
        foo(
            rspray(2,powers=0:9),
            rspray(2,powers=0:9),
            rspray(2,powers=0:9),
            rspray(2,powers=0:9),
            rspray(2,powers=0:9),
            rspray(2,powers=0:9),
            rspray(2,powers=0:9),
            rspray(2,powers=0:9)
        )
    }
})

## Four-square identity for sprays

test_that("integer spray powers",{
    S <- spray(as.matrix(expand.grid(0:1,0:1)),1:4)
    for(i in 0:10){
        expect_true(spray_power_scalar(S,i) == spray_power_scalar_stla(S,i))
    }    
})

## Increasing coverage of spray_ops.R 

test_that("test suite aab",{

    checker1 <- function(S){
        expect_error(!S)
        expect_true(+S == S)
        expect_error(S&S)
        expect_silent(jj <- 4*S)
        expect_silent(jj <- S*4)
        expect_silent(jj <- 4+S)
        expect_silent(jj <- S+4)
        expect_silent(jj <- S/4)
        expect_silent(jj <- -(S*0))
        expect_silent(jj <- -(0*S))
        expect_silent(jj <- S*(0*S))
        expect_silent(jj <- S*(S*0))
        expect_silent(jj <- (0*S)*S)
        expect_silent(jj <- (0*S)*S)
        expect_true(S != S+3)
        expect_true(S != 3+S)
        expect_error(4/S)
        expect_error(S^S)
        expect_error(S^(-9))
        expect_false(S+1e7 == 6)
        expect_true(S == S + (S*0))
        expect_true(S == (S*0) + S)
        expect_true(S != 1e7)
        expect_false(S == 1e7)
        expect_false(1000+S == S)
        expect_false(13+S == S*0)

        SS1 <- rspray(6,arity=119)
        SS2 <- rspray(6,arity=119)
        expect_false(SS1==SS1+SS2)
        expect_false(SS2==SS1+SS2)
        expect_false(SS1+SS2==SS1)
        expect_false(SS1+SS2==SS2)

        expect_true(spray_power_scalar     (S,0) == one(S))
        expect_true(spray_power_scalar_stla(S,0) == one(S))

        expect_true(spray_power_scalar     (S,1) == S)
        expect_true(spray_power_scalar_stla(S,1) == S)

        expect_true(spray_power_scalar     (S,2) == S*S)
        expect_true(spray_power_scalar_stla(S,2) == S*S)

        expect_true(spray_power_scalar     (S,3) == S*S*S)
        expect_true(spray_power_scalar_stla(S,3) == S*S*S)

        
        return(TRUE)
    }

    checker2 <- function(S1,S2){
        expect_false(S1==S2)
        return(TRUE)
    }

    checker2a <- function(S1,S2){
        expect_false(S1==S2)
        return(TRUE)
    }

    
    for(i in 1:3){
        checker1(rspray(8))
        checker2(rspray(8,arity=3),rspray(9,arity=4))
        checker2(rspray(8,arity=99),rspray(8,arity=99))
        checker2a(rspray(4,arity=119),rspray(5,arity=119))

    }

})

test_that("test suite aaa",{
    expect_true(coeffs(constant(subs(homog(2,2),1,10))) == 100)
    expect_true(coeffs(subs(product(1:3),3,10))==1000)

    a <- spray(diag(5))
    expect_true(is.empty(a[2,3,4,1,5]))

    ## Following test removes zero from the last row of index matrix
    ## M:
    expect_true(is.zero(spray(matrix(c(1,1,2,2),2,2),c(1,-1),addrepeats=TRUE)))

    ## Following test removes zero from not-the-last row of index matrix M:
    expect_silent(ignore <- spray(matrix(c(1,2,1,2,3,3),byrow=T,ncol=2),c(1,-1,10),addrepeats=TRUE))

    ## Following test checks a big-ish spray where multiple index rows
    ## cancel to zero:
    expect_true(is.zero(spray(kronecker(matrix(1,16,4),1+diag(2)),rep(c(1,1,-1,-1),length=32),addrepeats=TRUE)))

    ## test the addrepeats error:
    expect_error(spray(matrix(1,2,3)))
    expect_error(spray(spray(1:4)))
    expect_silent(spray(spray(1:4),3))
    
    expect_silent(spray(1:4,5))
    expect_error(spray(spray(1:4,5),x=1:2))


    expect_silent(S <- spray(matrix(1:7,5,7)))
    expect_error(coeffs(S) <- 1:2)
    expect_silent(coeffs(S) <- 13)

    expect_silent(as.spray(spray(diag(7))))
    expect_silent(as.spray(list(diag(9),seq_len(9))))
    expect_silent(as.spray(diag(9),seq_len(9)))
    expect_silent(as.spray(array(seq_len(24),2:4)))
    expect_silent(as.spray(array(seq_len(24),2:4),offbyone=TRUE))
    expect_error(as.spray(sin))


    expect_silent(dim(spray(diag(5),1:5)))
    expect_error(dim(spray(diag(5)-1,1:5)))

    expect_silent(as.array(spray(diag(5)+1,1:5)))
    expect_silent(as.array(spray(diag(5)+1,1:5),compact=TRUE))
    expect_silent(as.array(spray(diag(5)+1,1:5),compact=TRUE,offbyone=TRUE))

    expect_error(as.array(spray(diag(5),1:5)))
    expect_error(as.array(spray(diag(5)-4,1:5)))
    

    expect_error(spray_missing_accessor(0))

    S1 <- rspray(5)
    S2 <- rspray(5)
    expect_silent(S1[S2])
    expect_silent(S1[S2,drop=TRUE])

    expect_error(S1[rspray(n=3,arity=4)])

    expect_silent(S1[] <- 3)
    expect_silent(S1[] <- S2)
    expect_silent(S1[diag(3)] <- 3)
    expect_silent(S1[S2] <- 3)
    expect_silent(S2[1:2,1:2,1:2] <- 55)
    expect_error(S2[1:2,1:2] <- 55)
    expect_silent(S2[1:2,1:2,1:2] <- 55)
    expect_error(S2[1:2,1:2,1:2,1:2] <- 55)
    
    S1 <- spray(matrix(sample(-2:2,replace=TRUE,21),ncol=3),rnorm(7),addrepeats=TRUE)
    S2 <- spray(matrix(sample(-2:2,replace=TRUE,15),ncol=3),rnorm(5),addrepeats=TRUE)
    
    f1 <- as.function(S1)
    f2 <- as.function(S2)
    f3 <- as.function(S1*S2)
    x <- 4:6
    
    expect_equal(f1(x)*f2(x),f3(x))
    
    expect_silent(constant(S1) <- 3)

    expect_equal(S1,S1+zero(3))
     

    expect_silent(linear(1:4)+lone(3,4)+xyz(4)+one(4))
    expect_silent(one(rspray(9)))

    a <- homog(4,2)
    jj <-  (1-a)*ooom(a,3)
    expect_true(constant(jj,drop=TRUE)==1)
    expect_true(sum(rowSums(index(jj))==0)==1) 
    expect_true(all(rowSums(index(jj)) %in% c(0,8)))

    expect_output(print(rspray(6)))
    expect_output(print(S1-S1))

    options(polyform=TRUE)
    expect_output(print(rspray(6)))
    expect_output(print(100+rspray(6)))
    expect_output(print(100-rspray(6)))
    expect_output(print(S1-S1))

    expect_output(print(spray(diag(9))))
    expect_output(print(2.2*spray(diag(9))))
    expect_output(print(2.2*spray(diag(9))))
    options(sprayvars=letters)
    a <- diag(26)
    expect_output(print(spray(a)))
    expect_output(print(spray(matrix(0,2,3),5,addrepeats=TRUE)))


    
    S <- spray(matrix(sample(0:2,60,replace=TRUE),ncol=3),addrepeats=TRUE)
    expect_equal(arity(asum(S,1)),2)

    ## NB: following three tests must use '=='; expect_equal(asum(S,1),asum_inverted(S,c(2,3))) returns FALSE!
    expect_true(asum(S,1) == asum_inverted(S,c(2,3)))
    expect_true(asum(S,2) == asum_inverted(S,c(1,3)))
    expect_true(asum(S,3) == asum_inverted(S,c(1,2)))
    
    expect_equal(process_dimensions(S,c(TRUE,TRUE,FALSE)),1:2)
    expect_equal(constant(asum(S,1:3,drop=TRUE),drop=TRUE),20)
    expect_equal(constant(asum(S,1:3,drop=FALSE),drop=TRUE),20)


    ## Leibniz's rule:
    S1 <- spray(matrix(sample(0:3,replace=TRUE,21),ncol=3),sample(7),addrepeats=TRUE)
    S2 <- spray(matrix(sample(0:3,replace=TRUE,15),ncol=3),sample(5),addrepeats=TRUE)
    
    expect_true(S1*deriv(S2,1) + deriv(S1,1)*S2 == deriv(S1*S2,1))


    S1 <- rspray(100,vals=sample(100)-50)
    S2 <- rspray(100,vals=sample(100)-50)
    S3 <- rspray(100,vals=sample(100)-50)
    
     
    jj <- pmax(S1,S2,S3)
    expect_true(jj ==  maxpair_spray(S1,maxpair_spray(S2,S3)))
    expect_true(jj ==  maxpair_spray(maxpair_spray(S1,S2),S3))
    
    expect_true(pmax(S1,S2,S3)  == -pmin(-S1,-S2,-S3))
    expect_true(pmin(S1,S2,S3)  == -pmax(-S1,-S2,-S3))
    
    expect_true(pmax(S1,-Inf) == S1)
    expect_true(pmin(S1, Inf) == S1)


    expect_silent(jj <- minpair_spray(S1,S2))
    expect_silent(jj <- maxpair_spray(S1,S2))

    expect_true(minpair_spray(S1) == S1)
    expect_true(maxpair_spray(S1) == S1)

    expect_error(minpair_spray(S1,1:3))
    expect_error(maxpair_spray(S1,1:3))

    expect_error(minpair_spray(S1,-1))
    expect_error(maxpair_spray(S1,+1))

    SS1 <- rspray(5,arity=119)
    SS2 <- rspray(7,arity=119)
    expect_silent(minpair_spray(SS1,SS2))
    expect_silent(minpair_spray(SS2,SS1))
    expect_silent(maxpair_spray(SS1,SS2))
    expect_silent(maxpair_spray(SS2,SS1))

    
    expect_equal(constant(knight()^5,drop=TRUE),0)
    expect_equal(constant(king()^5,drop=TRUE),1200)

    expect_true(nterms(spray(diag(7)))==7)


    expect_true(S1^0 == one(arity(S1)))
    expect_true(S1^1 == S1)
    expect_true(S2^0 == one(arity(S2)))
    expect_true(S2^1 == S2)

    Sz <- spray(matrix(sample(1:50),ncol=2),10^-(1:25))
    expect_true(length(coeffs(Sz)) >= length(coeffs(zap(Sz))))
    expect_true(length(coeffs(Sz)) >= length(coeffs(zapsmall(Sz))))
    expect_true(length(coeffs(Sz)) >= length(zapsmall(coeffs(Sz))))

    S <- spray(matrix(c(0,0,1,0,1,2,1,2,0,1,3,2,1,3,0),ncol=3),1:5)
    expect_true(S[coeffs(S) > 3] == spray(matrix(c(1,0,1,0,0,3),ncol=3),5:4))
    expect_true(S[coeffs(S) < 4] == spray(matrix(c(1,0,0,2,1,2,1,2,3),ncol=3),3:1))

    S[coeffs(S) < 3] <- 99
    expect_true(S == spray(matrix(c(0,0,1,0,1,2,1,2,0,1,3,2,1,3,0),ncol=3),c(99,99,3:5)))

    expect_error(S[1])
    expect_error(S[1:2])
    expect_error(S[1] <- 5)
    expect_error(S[1:2] <- 5)

})

---
title: "spray power test"
author: "Robin Hankin"
date: "2024-04-07"
output: html_document
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
```

Function `spray_power_scalar_stla()` is an experimental replacement for spray powers.  This short document presents some timings for it.

```{r}
suppressMessages(library("spray"))
options(polyform = TRUE)
(S <- spray(as.matrix(expand.grid(0:1,0:1)),1:4))
system.time(ignore <- spray_power_scalar(S,63))
system.time(ignore <- spray_power_scalar_stla(S,63))
```
